;==========================================================================================
; Description:      Brain Pain - Game 2 Level 3
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================
#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit

Local $PcA[12], $xPos = -15, $yPos = 5, $SetC, $Count, $Score, $REle = Random(0, 10, 1)
Local $Amount[11] = ["15", "33", "23", "30", "30", "28", "15", "30", "21", "28", "34"]
Local $Path[11] = ["Adobe\", "Animated\", "Emotions\", "Software1\", "Software2\", _
		"Wabbit\", "Animals\", "Food\", "Fruit\", "Funny\", "Jap\"]
Local $PicWH[2][11] = [["55", "50", "50", "50", "50", "50", "62", "43", "56", "44", "40" ], _
		["55", "50", "50", "50", "50", "50", "62", "43", "58", "49", "52" ]]
Local $GUICW[2][11] = [["0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", _
		"0x000000", "0x000000", "0x000000", "0x000000", "0x000000" ], _
		["555", "555", "555", "555", "555", "555", "560", "545", "560", "545", "540" ]]

$Hui = GUICreate(_ObjDictGetValue($objLang, 'GameName'), $GUICW[1][$REle], 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, $GUICW[1][$REle], 335)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetBkColor(-1, $GUICW[0][$REle])

GUICtrlCreateGraphic($GUICW[1][$REle] - 90, 5, 85, 35)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(0, 45, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(0, 380, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
$Label1 = GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game2Q'), 5, 390, 600, 15)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("03:00", $GUICW[1][$REle] - 80, 7, 65, 25, $SS_CENTER)
GUICtrlSetFont(-1, 20)
GUICtrlSetColor(-1, 0x4A66FA)
$Label2 = GUICtrlCreateLabel("", 225, 10, 175, 25, $SS_CENTER)
GUICtrlSetFont(-1, 15, 500)
GUICtrlSetColor(-1, 0x4A66FA)
GUISetState()

If $REle > 5 Then
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0xFFFFFF)
Else
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0x000000)
EndIf
GUISetOnEvent(-3, "Close")

_PlaySong()

For $z = 1 To 20
	Playman()
	Timer()
Next

_Results($Label2, $Score, 3, "G2-L3")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

Func Timer()
	$Count = 2
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc   ;==>Timer

Func Playman()
	$SetC = 0
	Global $TrA[$Amount[$REle]]
	Global $Array[28] = ["50,70", "130,70", "210,70", "290,70", "370,70", "450,70", "530,70", _
			"50,150", "130,150", "210,150", "290,150", "370,150", "450,150", "530,150", _
			"50,230", "130,230", "210,230", "290,230", "370,230", "450,230", "530,230", _
			"50,310", "130,310", "210,310", "290,310", "370,310", "450,310", "530,310"]

	For $i = 0 To $Amount[$REle] - 1
		$TrA[$i] = $i + 1
	Next

	$Val = Random(7, 9, 1)
	Global $rnArray[$Val + 1], $rmArray[$Val + 1]
	For $b = 0 To $Val
		$Ran_D = Random(0, UBound($TrA) - 1, 1)
		$randomEle = Random(0, UBound($Array) - 1, 1)
		$rnArray[$b] = $TrA[$Ran_D]
		$rmArray[$b] = $Array[$randomEle]
		_ArrayDelete($TrA, $Ran_D)
		_ArrayDelete($Array, $randomEle)
	Next

	For $d = 0 To $Val
		$Split = StringSplit($rmArray[$d], ",")
		$PcA[$d] = GUICtrlCreatePic($PicPath & $Path[$REle] & $rnArray[$d] & ".bmp", _
				$Split[1] - 40, $Split[2], $PicWH[0][$REle], $PicWH[1][$REle])
		GUICtrlSetState(-1, $GUI_HIDE)
		GUICtrlSetOnEvent(-1, "WrongAnW")
		GUICtrlSetCursor(-1, 0)
	Next

	$Rrr = Random(0, UBound($TrA) - 1, 1)
	For $a = $Val + 1 To $Val + 2
		$Srr = Random(0, UBound($Array) - 1, 1)
		$Split = StringSplit($Array[$Srr], ",")
		$PcA[$a] = GUICtrlCreatePic($PicPath & $Path[$REle] & $TrA[$Rrr] & ".bmp", _
				$Split[1] - 40, $Split[2], $PicWH[0][$REle], $PicWH[1][$REle])
		GUICtrlSetState(-1, $GUI_HIDE)
		GUICtrlSetOnEvent(-1, "CorrectAnW")
		GUICtrlSetCursor(-1, 0)
		_ArrayDelete($Array, $Srr)
	Next

	For $i = 0 To UBound($PcA) - 1
		GUICtrlSetState($PcA[$i], $GUI_SHOW)
	Next
EndFunc   ;==>Playman

Func CorrectAnW()
	$SetC = 1
	TurnOFF()
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	_FlashControl($AddPic, 300)
	$Score += 1
	For $i = 0 To UBound($PcA) - 1
		GUICtrlDelete($PcA[$i])
	Next
EndFunc   ;==>CorrectAnW

Func WrongAnW()
	$SetC = 1
	TurnOFF()
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	_FlashControl($AddPic, 300)
	For $i = 0 To UBound($PcA) - 1
		GUICtrlDelete($PcA[$i])
	Next
EndFunc   ;==>WrongAnW

Func TurnOFF()
	GUICtrlSetData($Time, "03:00")
	For $i = 0 To UBound($PcA) - 1
		GUICtrlSetOnEvent($PcA[$i], "")
	Next
EndFunc   ;==>TurnOFF