;==========================================================================================
; Description:      Brain Pain - Game 12 Level 2
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit
Local $count, $SetC, $count, $xPos = -15, $yPos = 5, $score, $Array[9], $ArrLab[4]
$Hui = GUICreate("", 555, 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, 600, 335)
GUICtrlSetBkColor(-1, 0xFFFFFF)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateGraphic(0, 45, 610, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(0, 380, 610, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(465, 5, 85, 35)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("04:00", 475, 7, 65, 25, $SS_CENTER)
GUICtrlSetColor($Time, 0x4A66FA)
GUICtrlSetFont(-1, 20)
GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game8Q'), 5, 390, 120, 20)
GUICtrlSetColor(-1, 0x4A66FA)
GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'ChooseAnAnwser'), 415, 390, 135, 20)
GUICtrlSetColor(-1, 0x4A66FA)
$label2 = GUICtrlCreateLabel("", 250, 10, 175, 25, $SS_CENTER)
GUICtrlSetColor($label2, 0x4A66FA)
GUICtrlSetFont(-1, 15, 500)
GUISetState()

_PrePare(230, 135, 0x4A66FA)

GUISetOnEvent(-3, "Close")

GUICtrlCreateGraphic(415, 110, 135, 190)
GUICtrlSetColor(-1, 0x000000)
GUICtrlSetState(-1, $GUI_DISABLE)

$LabelQ = GUICtrlCreateLabel("? + ? = ?", 5, 190, 300, 35, BitOR($SS_CENTER, $SS_CENTERIMAGE))
GUICtrlSetFont(-1, 22)
GUICtrlSetBkColor(-1, 0xFFD046)

$ArrLab[0] = GUICtrlCreateLabel("", 420, 140, 50, 40, BitOR($SS_CENTER, $SS_CENTERIMAGE))
$ArrLab[1] = GUICtrlCreateLabel("", 495, 140, 50, 40, BitOR($SS_CENTER, $SS_CENTERIMAGE))
$ArrLab[2] = GUICtrlCreateLabel("", 420, 230, 50, 40, BitOR($SS_CENTER, $SS_CENTERIMAGE))
$ArrLab[3] = GUICtrlCreateLabel("", 495, 230, 50, 40, BitOR($SS_CENTER, $SS_CENTERIMAGE))
For $o = 0 To UBound($ArrLab) - 1
	GUICtrlSetFont($ArrLab[$o], 15, 750)
	GUICtrlSetBkColor($ArrLab[$o], 0xFFD046)
	GUICtrlSetCursor($ArrLab[$o], 0)
Next

_PlaySong ()

For $i = 1 To 15
	PlayTime()
	Timer()
Next

_Results($Label2, $Score, 2, "G12-L2")
_FlashControl($label2, 400)
Sleep(1000)
Close()

Func PlayTime()
	$SetC = 0
	$Total = 0
	$Ran_E = Random(1, 3, 1)
	$Ran_D = Random(1, 9, 1)
	$Ran_Y = Random(1, 9, 1)
	If $Ran_E = 1 Then
		$Qts = _ObjDictGetValue($objLang, 'plus')
		$Total = $Ran_D + $Ran_Y
	ElseIf $Ran_E = 2 Then
		$Qts =_ObjDictGetValue($objLang, 'minus')
		If $Ran_D - $Ran_Y < 0 Then
			Local $Tmp = $Ran_D
			$Ran_D = $Ran_Y
			$Ran_Y = $Tmp
		EndIf
		$Total = $Ran_D - $Ran_Y
	ElseIf $Ran_E = 3 Then
		$Qts =_ObjDictGetValue($objLang, 'times')
		$Total = $Ran_D * $Ran_Y
	EndIf
	$Ran_D = _Convert($Ran_D)
	$Ran_Y = _Convert($Ran_Y)
	GUICtrlSetData($LabelQ, $Ran_D & " " & $Qts & " " & $Ran_Y & " = ?")

	If $Total > 10 Then
		Global $TrA[1]
		For $i = $Total - 10 To $Total + 5
			ReDim $TrA[UBound($TrA) + 1]
			$TrA[0] = $TrA[0] + 1
			$TrA[UBound($TrA) - 1] = $i
		Next
	Else
		Global $TrA[9]
		For $i = 0 To 8
			$TrA[$i] = $i + 1
		Next
	EndIf
	For $i = 0 To 3
		$Ran_N = Random(0, UBound($TrA) - 1, 1)
		If $Total = $TrA[$Ran_N] Then $TrA[$Ran_N] = $Total + 1
		GUICtrlSetData($ArrLab[$i], $TrA[$Ran_N])
		GUICtrlSetOnEvent($ArrLab[$i], "WrongAnw")
		_ArrayDelete($TrA, $Ran_N)
	Next
	$Ran_M = Random(1, 4, 1)
	If $Ran_M = 1 Then
		GUICtrlSetData($ArrLab[0], $Total)
		GUICtrlSetOnEvent($ArrLab[0], "CorrectAnW")
	ElseIf $Ran_M = 2 Then
		GUICtrlSetData($ArrLab[1], $Total)
		GUICtrlSetOnEvent($ArrLab[1], "CorrectAnW")
	ElseIf $Ran_M = 3 Then
		GUICtrlSetData($ArrLab[2], $Total)
		GUICtrlSetOnEvent($ArrLab[2], "CorrectAnW")
	ElseIf $Ran_M = 4 Then
		GUICtrlSetData($ArrLab[3], $Total)
		GUICtrlSetOnEvent($ArrLab[3], "CorrectAnW")
	EndIf
EndFunc

Func _Convert($Value)
	If $Value = "1" Then
		Return _ObjDictGetValue($objLang, 'one')
	ElseIf $Value = "2" Then
		Return _ObjDictGetValue($objLang, 'two')
	ElseIf $Value = "3" Then
		Return _ObjDictGetValue($objLang, 'three')
	ElseIf $Value = "4" Then
		Return _ObjDictGetValue($objLang, 'four')
	ElseIf $Value = "5" Then
		Return _ObjDictGetValue($objLang, 'five')
	ElseIf $Value = "6" Then
		Return _ObjDictGetValue($objLang, 'six')
	ElseIf $Value = "7" Then
		Return _ObjDictGetValue($objLang, 'seven')
	ElseIf $Value = "8" Then
		Return _ObjDictGetValue($objLang, 'eight')
	ElseIf $Value = "9" Then
		Return _ObjDictGetValue($objLang, 'nine')
	EndIf
EndFunc

Func Timer()
	$count = 3
	While $count > 0
		For $z = 0 To $count
			If $SetC = 1 Then $count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $count & ":" & $i)
				Sleep(10)
			Next
			$count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func CorrectAnW()
	For $i = 0 To UBound($ArrLab) - 1
		GUICtrlSetOnEvent($ArrLab[$i], "")
	Next
	$SetC = 1
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	GUICtrlSetData($Time, "04:00")
	_FlashControl($AddPic, 300)
	$score += 1
EndFunc

Func WrongAnW()
	For $i = 0 To UBound($ArrLab) - 1
		GUICtrlSetOnEvent($ArrLab[$i], "")
	Next
	$SetC = 1
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	GUICtrlSetData($Time, "04:00")
	_FlashControl($AddPic, 300)
EndFunc