;==========================================================================================
; Description:      Brain Pain - Game 20 Level 2
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit
Local $xPos = -15, $yPos = 5, $SetC, $Count, $Score, $PcA[11], $REle = Random(0, 10, 1), $Array
Local $LocalPic, $total, $Hold, $R_Val, $Anwsers[4], $o, $PicArr[12]
Local $Amount[11] = ["15", "33", "23", "30", "30", "28", "15", "30", "21", "28", "34"]
Local $Path[11] = ["Adobe\", "Animated\", "Emotions\", "Software1\", "Software2\", _
		"Wabbit\", "Animals\", "Food\", "Fruit\", "Funny\", "Jap\"]
Local $PicWH[2][11] = [["55", "50", "50", "50", "50", "50", "62", "43", "56", "44", "40"], _
		["55", "50", "50", "50", "50", "50", "62", "43", "58", "49", "52"]]
Local $GUICW[2][11] = [["0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", _
		"0x000000", "0x000000", "0x000000", "0x000000", "0x000000"], _
		["555", "555", "555", "555", "555", "555", "560", "545", "560", "545", "540"]]

$Hui = GUICreate("Brain Pain", $GUICW[1][$REle], 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, $GUICW[1][$REle], 335)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetBkColor(-1, $GUICW[0][$REle])

$Gr0 = GUICtrlCreateGraphic($GUICW[1][$REle] - 90, 5, 85, 35)
GUICtrlSetColor(-1, 0x000000)
$Gr1 = GUICtrlCreateGraphic(0, 45, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
$Gr2 = GUICtrlCreateGraphic(0, 380, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
$Label1 = GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game20Q'), 5, 390, 600, 15)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("04:00", $GUICW[1][$REle] - 80, 7, 65, 25, $SS_CENTER)
GUICtrlSetFont(-1, 20)
GUICtrlSetColor(-1, 0x4A66FA)
$Label2 = GUICtrlCreateLabel("", 225, 10, 175, 25, $SS_CENTER)
GUICtrlSetFont(-1, 15, 500)
GUICtrlSetColor(-1, 0x4A66FA)
GUISetState()

If $REle > 5 Then
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0xFFFFFF)
Else
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0x000000)
EndIf

GUISetOnEvent(-3, "Close")

$Picture = GUICtrlCreatePic($Hold, 440, 90, $PicWH[0][$REle], $PicWH[1][$REle])
$Anwsers[0] = GUICtrlCreateLabel("", 410, 180, 50, 35, $SS_CENTER)
$Anwsers[1] = GUICtrlCreateLabel("", 485, 180, 50, 35, $SS_CENTER)
$Anwsers[2] = GUICtrlCreateLabel("", 410, 250, 50, 35, $SS_CENTER)
$Anwsers[3] = GUICtrlCreateLabel("", 485, 250, 50, 35, $SS_CENTER)
For $i = 0 To UBound($Anwsers) - 1
	GUICtrlSetBkColor($Anwsers[$i], 0xEFEFEF)
	GUICtrlSetFont($Anwsers[$i], 24)
	GUICtrlSetCursor($Anwsers[$i], 0)
Next

_PlaySong()

For $a = 1 To 15
	GeneratePics()
	Calculate()
	Timer()
Next

_Results($Label2, $Score, 2, "G20-L2")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

Func Timer()
	$Count = 3
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func GeneratePics()
	For $p = 0 To UBound($PicArr) - 1
		GUICtrlDelete($PicArr[$p])
	Next
	$total = 12
	$o = 0
	Global $Array[12] = ["30,90", "110,90", "190,90", "270,90", _
			"30,170", "110,170", "190,170", "270,170", _
			"30,250", "110,250", "190,250", "270,250"]
	Global $TrA[$Amount[$REle]]
	For $i = 0 To $Amount[$REle] - 1
		$TrA[$i] = $i + 1
	Next

	$R_Val = Random(3, 8, 1)
	$Ran_D = Random(0, UBound($TrA) - 1, 1)
	$LocalPic = $PicPath & $Path[$REle] & $TrA[$Ran_D] & ".bmp" 
	$Hold = $LocalPic
	_ArrayDelete($TrA, $Ran_D)

	For $i = 1 To $R_Val
		RandomPos()
		$o += 1
	Next
	$total -= $R_Val

	$Ran_D = Random(0, UBound($TrA) - 1, 1)
	$LocalPic = $PicPath & $Path[$REle] & $TrA[$Ran_D] & ".bmp" 
	_ArrayDelete($TrA, $Ran_D)

	For $i = 1 To $total - 1
		RandomPos()
		$o += 1
	Next

	$Ran_D = Random(0, UBound($TrA) - 1, 1)
	$LocalPic = $PicPath & $Path[$REle] & $TrA[$Ran_D] & ".bmp" 
	_ArrayDelete($TrA, $Ran_D)
	RandomPos()
	$o += 1

	GUICtrlSetImage($Picture, $Hold)
	$SetC = 0
EndFunc

Func RandomPos()
	$R_Ele = Random(0, UBound($Array) - 1, 1)
	$Split = StringSplit($Array[$R_Ele], ",")
	$PicArr[$o] = GUICtrlCreatePic($LocalPic, $Split[1], $Split[2], $PicWH[0][$REle], $PicWH[1][$REle])
	_ArrayDelete($Array, $R_Ele)
EndFunc

Func Calculate()
	Global $AnwsersData[3] = [$R_Val + 1, $R_Val + 2, $R_Val - 1]
	Global $AnwsersArray[4] = [$Anwsers[0], $Anwsers[1], $Anwsers[2], $Anwsers[3]]
	$MoreR = Random(0, UBound($AnwsersArray) - 1, 1)
	GUICtrlSetData($AnwsersArray[$MoreR], $R_Val)
	GUICtrlSetOnEvent($AnwsersArray[$MoreR], "CorrectAnW")
	_ArrayDelete($AnwsersArray, $MoreR)
	For $i = 0 To 2
		$MoreR = Random(0, UBound($AnwsersArray) - 1, 1)
		$MoreS = Random(0, UBound($AnwsersData) - 1, 1)
		GUICtrlSetData($AnwsersArray[$MoreR], $AnwsersData[$MoreS])
		GUICtrlSetOnEvent($AnwsersArray[$MoreR], "WrongAnW")
		_ArrayDelete($AnwsersArray, $MoreR)
		_ArrayDelete($AnwsersData, $MoreS)
	Next
EndFunc

Func CorrectAnW()
	$SetC = 1
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	For $n = 0 To UBound($Anwsers) - 1
		GUICtrlSetOnEvent($Anwsers[$n], "")
	Next
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	GUICtrlSetData($Time, "04:00")
	_FlashControl($AddPic, 300)
	$Score += 1
EndFunc

Func WrongAnW()
	$SetC = 1
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	For $n = 0 To UBound($Anwsers) - 1
		GUICtrlSetOnEvent($Anwsers[$n], "")
	Next
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	GUICtrlSetData($Time, "04:00")
	_FlashControl($AddPic, 300)
EndFunc