;==========================================================================================
; Description:      Brain Pain - Game 28 Level 1
; Author(s):        MrBond007 (Baki G)
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit
Local $Pic[3], $Reverse_R, $x, $y, $xx, $yy, $times
Local $xPos = -15, $SetC, $Count, $Score, $PcA[10], $REle = Random(0, 10, 1), $Array[3]
Local $Amount[11] = ["15", "33", "23", "30", "30", "28", "15", "30", "21", "28", "34"]
Local $Path[11] = ["Adobe\", "Animated\", "Emotions\", "Software1\", "Software2\", _
		"Wabbit\", "Animals\", "Food\", "Fruit\", "Funny\", "Jap\"]
Local $PicWH[2][11] = [["55", "50", "50", "50", "50", "50", "62", "43", "56", "44", "40"], _
		["55", "50", "50", "50", "50", "50", "62", "43", "58", "49", "52"]]
Local $GUICW[2][11] = [["0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", _
		"0x000000", "0x000000", "0x000000", "0x000000", "0x000000"], _
		["555", "555", "555", "555", "555", "555", "560", "545", "560", "545", "540"]]

$Hui = GUICreate("Brain Pain", $GUICW[1][$REle], 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, $GUICW[1][$REle], 335)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetBkColor(-1, $GUICW[0][$REle])

$Gr0 = GUICtrlCreateGraphic($GUICW[1][$REle] - 90, 5, 85, 35)
GUICtrlSetColor(-1, 0x000000)
$Gr1 = GUICtrlCreateGraphic(0, 45, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
$Gr2 = GUICtrlCreateGraphic(0, 380, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
$Label1 = GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game28Q'), 5, 390, 600, 15)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("03:00", $GUICW[1][$REle] - 80, 7, 65, 25, $SS_CENTER)
GUICtrlSetFont(-1, 20)
GUICtrlSetColor(-1, 0x4A66FA)
$Label2 = GUICtrlCreateLabel("", 225, 10, 175, 25, $SS_CENTER)
GUICtrlSetFont(-1, 15, 500)
GUICtrlSetColor(-1, 0x4A66FA)
GUISetState()

If $REle > 5 Then
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0xFFFFFF)
Else
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0x000000)
EndIf

GUISetOnEvent(-3, "Close")

_PlaySong()

For $s = 1 To 10
	Generate()
	Timer()
Next

_Results($Label2, $Score, 1, "G28-L1")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

Func Timer()
	$Count = 2
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func GeneRage()
	Global $TrA[$Amount[$REle]], $PosArr[3] = ["120", "240", "360"]
	For $a = 0 To $Amount[$REle] - 1
		$TrA[$a] = $a + 1
	Next
	For $n = 0 To UBound($Pic) - 1
		$Ran_D = Random(1, UBound($TrA) - 1, 1)
		$Array[$n] = $PicPath & $Path[$REle] & $Ran_D & ".bmp" 
		$Pic[$n] = GUICtrlCreatePic($PicPath & $Path[$REle] & $Ran_D & ".bmp", $PosArr[$n], 180, $PicWH[0][$REle], $PicWH[1][$REle])
		GUICtrlSetCursor($Pic[$n], 0)
		GUICtrlSetState($Pic[$n], $GUI_DISABLE)
	Next
	$Reverse_R = Random(1, 3, 1)
	If $Reverse_R = 1 Then
		For $i = 1 To 3
			ControlMove($Hui, "", $Pic[2], 360, 100)
			Sleep(200)
			ControlMove($Hui, "", $Pic[2], 360, 180)
			Sleep(200)
		Next
	ElseIf $Reverse_R = 2 Then
		For $i = 1 To 3
			ControlMove($Hui, "", $Pic[1], 240, 100)
			Sleep(200)
			ControlMove($Hui, "", $Pic[1], 240, 180)
			Sleep(200)
		Next
	ElseIf $Reverse_R = 3 Then
		For $i = 1 To 3
			ControlMove($Hui, "", $Pic[0], 120, 100)
			Sleep(200)
			ControlMove($Hui, "", $Pic[0], 120, 180)
			Sleep(200)
		Next
	EndIf
	For $n = 0 To UBound($Pic) - 1
		GUICtrlSetImage($Pic[$n], $PicPath & "roclee.bmp")
	Next
EndFunc

Func RandomSwaP()
	$Pos1 = ControlGetPos($Hui, "", $Pic[0])
	$Pos2 = ControlGetPos($Hui, "", $Pic[1])
	$Pos3 = ControlGetPos($Hui, "", $Pic[2])
	$SWP = Random(1, 4, 1)
	If $SWP = 1 Then
		If $Pos1[0] = 120 And $Pos2[0] = 240 Then
			SwapPos($Pic[0], $Pic[1], 120, 180, 240, 180, 60)
		ElseIf $Pos1[0] = 120 And $Pos3[0] = 240 Then
			SwapPos($Pic[0], $Pic[2], 120, 180, 240, 180, 60)
		ElseIf $Pos2[0] = 120 And $Pos1[0] = 240 Then
			SwapPos($Pic[1], $Pic[0], 120, 180, 240, 180, 60)
		Else
			RandomSwaP()
		EndIf
	ElseIf $SWP = 2 Then
		If $Pos2[0] = 120 And $Pos3[0] = 240 Then
			SwapPos($Pic[1], $Pic[2], 120, 180, 240, 180, 60)
		ElseIf $Pos3[0] = 120 And $Pos1[0] = 240 Then
			SwapPos($Pic[2], $Pic[0], 120, 180, 240, 180, 60)
		ElseIf $Pos3[0] = 120 And $Pos2[0] = 240 Then
			SwapPos($Pic[2], $Pic[1], 120, 180, 240, 180, 60)
		Else
			RandomSwaP()
		EndIf
	ElseIf $SWP = 3 Then
		If $Pos1[0] = 240 And $Pos2[0] = 360 Then
			SwapPos($Pic[0], $Pic[1], 240, 180, 360, 180, 60)
		ElseIf $Pos1[0] = 240 And $Pos3[0] = 360 Then
			SwapPos($Pic[0], $Pic[2], 240, 180, 360, 180, 60)
		ElseIf $Pos2[0] = 240 And $Pos1[0] = 360 Then
			SwapPos($Pic[1], $Pic[0], 240, 180, 360, 180, 60)
		Else
			RandomSwaP()
		EndIf
	ElseIf $SWP = 4 Then
		If $Pos2[0] = 240 And $Pos3[0] = 360 Then
			SwapPos($Pic[1], $Pic[2], 240, 180, 360, 180, 60)
		ElseIf $Pos3[0] = 240 And $Pos1[0] = 360 Then
			SwapPos($Pic[2], $Pic[0], 240, 180, 360, 180, 60)
		ElseIf $Pos3[0] = 240 And $Pos2[0] = 360 Then
			SwapPos($Pic[2], $Pic[1], 240, 180, 360, 180, 60)
		Else
			RandomSwaP()
		EndIf
	EndIf
EndFunc

Func SwapPos($C1, $C2, $x, $y, $xx, $yy, $id)
	For $a = 1 To 20
		For $i = 1 To $id / 20
			$x += 1
			$y -= 1
			$xx -= 1
			$yy += 1
			ControlMove($Hui, "", $C1, $x, $y)
			ControlMove($Hui, "", $C2, $xx, $yy)
		Next
		Sleep(10)
	Next
	For $a = 1 To 20
		For $i = 1 To $id / 20
			$x += 1
			$y += 1
			$xx -= 1
			$yy -= 1
			ControlMove($Hui, "", $C1, $x, $y)
			ControlMove($Hui, "", $C2, $xx, $yy)
		Next
		Sleep(10)
	Next
EndFunc

Func Anwsers()
	For $i = 0 To UBound($Pic) - 1
		GUICtrlSetState($Pic[$i], $GUI_ENABLE)
		GUICtrlSetOnEvent($Pic[$i], "WrongAnW")
	Next
	If $Reverse_R = 1 Then
		GUICtrlSetOnEvent($Pic[2], "CorrectAnW")
	ElseIf $Reverse_R = 2 Then
		GUICtrlSetOnEvent($Pic[1], "CorrectAnW")
	ElseIf $Reverse_R = 3 Then
		GUICtrlSetOnEvent($Pic[0], "CorrectAnW")
	EndIf
EndFunc

Func Generate()
	$SetC = 0
	GeneRage()
	For $i = 1 To 4
		RandomSwaP()
	Next
	Anwsers()
EndFunc

Func CorrectAnW()
	$SetC = 1
	TurnOFF()
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, 15, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	_FlashControl($AddPic, 300)
	$Score += 1
	GUICtrlDelete($Pic[0])
	GUICtrlDelete($Pic[1])
	GUICtrlDelete($Pic[2])
EndFunc

Func WrongAnW()
	$SetC = 1
	TurnOFF()
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, 15, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	_FlashControl($AddPic, 300)
	GUICtrlDelete($Pic[0])
	GUICtrlDelete($Pic[1])
	GUICtrlDelete($Pic[2])
EndFunc

Func TurnOFF()
	GUICtrlSetData($Time, "03:00")
	For $i = 0 To UBound($Pic) - 1
		GUICtrlSetOnEvent($Pic[$i], "")
		GUICtrlSetImage($Pic[$i], $Array[$i])
	Next
EndFunc