;==========================================================================================
; Description:      Brain Pain - Game 30 Level 4
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit
Local $xPos = -15, $yPos = 5, $Gra[4], $Dots[19], $jin[34]
Local $SetC, $Count, $Score
$Hui = GUICreate("", 540, 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, 540, 335)
GUICtrlSetBkColor(-1, 0xFFFFFF)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateGraphic(0, 45, 550, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(450, 5, 85, 35)
GUICtrlSetColor(-1, 0x4A66FA)
GUICtrlCreateGraphic(0, 380, 550, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game30Q'), 5, 390, 600, 15)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("02:00", 460, 7, 65, 25, $SS_CENTER)
GUICtrlSetFont(-1, 20)
GUICtrlSetColor(-1, 0x4A66FA)
$Label2 = GUICtrlCreateLabel("", 260, 10, 175, 25, $SS_CENTER)
GUICtrlSetFont(-1, 15, 500)
GUICtrlSetColor(-1, 0x4A66FA)
GUISetState()

_PrePare(220, 135, 0x4A66FA)

GUISetOnEvent(-3, "Close")

GUICtrlCreateGraphic(30, 160, 130, 100)
GUICtrlSetColor(-1, 0x000000)
Local $Position[4] = ["230,90", "390,90", "230,240", "390,240"]
For $i = 0 To UBound($Gra) - 1
	$Split = StringSplit($Position[$i], ",")
	$Gra[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 130, 100)
	GUICtrlSetColor(-1, 0x000000)
	GUICtrlSetCursor(-1, 0)
Next

_PlaySong ()

For $i = 1 To 20
	PlayTime()
	Timer()
Next

_Results($Label2, $Score, 3, "G30-L4")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

While 1
	Sleep(100)
WEnd

Func Timer()
	$Count = 1
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func PlayTime()
	$SetC = 0

	For $i = 0 To UBound($Dots) - 1
		GUICtrlDelete($Dots[$i])
	Next
	For $i = 0 To UBound($jin) - 1
		GUICtrlDelete($jin[$i])
	Next
	For $i = 0 To UBound($Gra) - 1
		GUICtrlSetOnEvent($Gra[$i], "WrongAnW")
	Next

	Local $Colors[4] = ["0xFF0000", "0xFFFF00", "0x0000FF", "0x00FF00"]
	Local $Array[12] = ["40,170", "70,170", "100,170", "130,170", _
			"40,200", "70,200", "100,200", "130,200", _
			"40,230", "70,230", "100,230", "130,230"]
	Local $Manda[4] = ["+200,-70", "+360,-70", "+200,+80", "+360,+80"]

	$Val = 7
	Local $n = $Val + 1
	$Randa = Random(0, UBound($Manda) - 1, 1)
	If $Randa = 0 Then
		_Draw(0, 1, 1, 1)
		GUICtrlSetOnEvent($Gra[0], "CorrectAnW")
	ElseIf $Randa = 1 Then
		_Draw(1, 0, 1, 1)
		GUICtrlSetOnEvent($Gra[1], "CorrectAnW")
	ElseIf $Randa = 2 Then
		_Draw(1, 1, 0, 1)
		GUICtrlSetOnEvent($Gra[2], "CorrectAnW")
	ElseIf $Randa = 3 Then
		_Draw(1, 1, 1, 0)
		GUICtrlSetOnEvent($Gra[3], "CorrectAnW")
	EndIf
	$Splits = StringSplit($Manda[$Randa], ",")
	For $i = 0 To $Val
		$n += 1
		$Ran_D = Random(0, UBound($Colors) - 1, 1)
		$Ran_Y = Random(0, UBound($Array) - 1, 1)
		$Split = StringSplit($Array[$Ran_Y], ",")
		$Dots[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
		GUICtrlSetGraphic($Dots[$i], $GUI_GR_COLOR, $Colors[$Ran_D], $Colors[$Ran_D])
		GUICtrlSetGraphic($Dots[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
		GUICtrlSetBkColor($Dots[$i], 0xFFFFFF)

		$Dots[$n] = GUICtrlCreateGraphic($Split[1] + $Splits[1], $Split[2] + $Splits[2], 20, 20)
		GUICtrlSetGraphic($Dots[$n], $GUI_GR_COLOR, $Colors[$Ran_D], $Colors[$Ran_D])
		GUICtrlSetGraphic($Dots[$n], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
		GUICtrlSetBkColor($Dots[$n], 0xFFFFFF)
		_ArrayDelete($Array, $Ran_Y)
	Next
	_ArrayDelete($Manda, $Randa)
EndFunc

Func _Draw($Cir1, $Cir2, $Cir3, $Cir4)
	Local $Colors[4] = ["0xFF0000", "0xFFFF00", "0x0000FF", "0x00FF00" ]
	If $Cir1 = 1 Then
		Local $Marray[12] = ["240,100", "270,100", "300,100", "330,100", _
				"240,130", "270,130", "300,130", "330,130", _
				"240,160", "270,160", "300,160", "330,160"]
		For $i = 0 To 6
			$Ran_D = Random(0, UBound($Marray) - 1, 1)
			$Ran_Y = Random(0, UBound($Colors) - 1, 1)
			$Split = StringSplit($Marray[$Ran_D], ",")
			$jin[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
			GUICtrlSetGraphic($jin[$i], $GUI_GR_COLOR, $Colors[$Ran_Y], $Colors[$Ran_Y])
			GUICtrlSetGraphic($jin[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
			GUICtrlSetBkColor($jin[$i], 0xFFFFFF)
			_ArrayDelete($Marray, $Ran_D)
		Next
	EndIf

	If $Cir2 = 1 Then
		Local $Marray[12] = ["400,100", "430,100", "460,100", "490,100", _
				"400,130", "430,130", "460,130", "490,130", _
				"400,160", "430,160", "460,160", "490,160"]
		For $i = 7 To 15
			$Ran_D = Random(0, UBound($Marray) - 1, 1)
			$Ran_Y = Random(0, UBound($Colors) - 1, 1)
			$Split = StringSplit($Marray[$Ran_D], ",")
			$jin[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
			GUICtrlSetGraphic($jin[$i], $GUI_GR_COLOR, $Colors[$Ran_Y], $Colors[$Ran_Y])
			GUICtrlSetGraphic($jin[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
			GUICtrlSetBkColor($jin[$i], 0xFFFFFF)
			_ArrayDelete($Marray, $Ran_D)
		Next
	EndIf

	If $Cir3 = 1 Then
		Local $Marray[12] = ["240,250", "270,250", "300,250", "330,250", _
				"240,280", "270,280", "300,280", "330,280", _
				"240,310", "270,310", "300,310", "330,310"]
		For $i = 16 To 24
			$Ran_D = Random(0, UBound($Marray) - 1, 1)
			$Ran_Y = Random(0, UBound($Colors) - 1, 1)
			$Split = StringSplit($Marray[$Ran_D], ",")
			$jin[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
			GUICtrlSetGraphic($jin[$i], $GUI_GR_COLOR, $Colors[$Ran_Y], $Colors[$Ran_Y])
			GUICtrlSetGraphic($jin[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
			GUICtrlSetBkColor($jin[$i], 0xFFFFFF)
			_ArrayDelete($Marray, $Ran_D)
		Next
	EndIf

	If $Cir4 = 1 Then
		Local $Marray[12] = ["400,250", "430,250", "460,250", "490,250", _
				"400,280", "430,280", "460,280", "490,280", _
				"400,310", "430,310", "460,310", "490,310"]
		For $i = 25 To 32
			$Ran_D = Random(0, UBound($Marray) - 1, 1)
			$Ran_Y = Random(0, UBound($Colors) - 1, 1)
			$Split = StringSplit($Marray[$Ran_D], ",")
			$jin[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
			GUICtrlSetGraphic($jin[$i], $GUI_GR_COLOR, $Colors[$Ran_Y], $Colors[$Ran_Y])
			GUICtrlSetGraphic($jin[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
			GUICtrlSetBkColor($jin[$i], 0xFFFFFF)
			_ArrayDelete($Marray, $Ran_D)
		Next
	EndIf
EndFunc

Func CorrectAnW()
	$SetC = 1
	TurnOFF()
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	_FlashControl($AddPic, 300)
	$Score += 1
EndFunc

Func WrongAnW()
	$SetC = 1
	TurnOFF()
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	_FlashControl($AddPic, 300)
EndFunc

Func TurnOFF()
	GUICtrlSetData($Time, "02:00")
	For $i = 0 To UBound($Gra) - 1
		GUICtrlSetOnEvent($Gra[$i], "")
	Next
EndFunc