;==========================================================================================
; Description:      Brain Pain - Game 7 Level 4
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit

Local $rRd, $sctot, $array[24], $xPos = -15, $yPos = 5, $SetC, $Count, $Score
$Hui = GUICreate(_ObjDictGetValue($objLang, 'GameName'), 555, 450, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 50, 600, 370)
GUICtrlSetBkColor(-1, 0xFFFFFF)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateGraphic(0, 50, 610, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(465, 5, 85, 35)
GUICtrlSetColor(-1, 0x4A66FA)
GUICtrlCreateGraphic(0, 420, 610, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game7Q'), 5, 430, 600, 15)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("02:00", 475, 7, 65, 25, $SS_CENTER)
GUICtrlSetColor($Time, 0x4A66FA)
GUICtrlSetFont(-1, 20)
$Label2 = GUICtrlCreateLabel("", 235, 10, 175, 25, $SS_CENTER)
GUICtrlSetColor($Label2, 0x4A66FA)
GUICtrlSetFont(-1, 15, 500)
GUISetState()

_PrePare(230, 155, 0x4A66FA)

GUISetOnEvent(-3, "Close")

$Gra1 = GUICtrlCreateGraphic(-1, 65, 265, 345)
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetCursor(-1, 0)
$Gra2 = GUICtrlCreateGraphic(291, 65, 265, 345)
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetCursor(-1, 0)

_PlaySong()

For $m = 1 To 20
	PlayTime()
	Timer()
Next

_Results($Label2, $Score, 3, "G7-L4")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

Func Timer()
	$Count = 1
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func Randompics()
	$sctot = ""
	$rRd = Random(1, 6, 1)
	If $rRd = 1 Then
		$sctot = 1
	ElseIf $rRd = 2 Then
		$sctot = 5
	ElseIf $rRd = 3 Then
		$sctot = 10
	ElseIf $rRd = 4 Then
		$sctot = 25
	ElseIf $rRd = 5 Then
		$sctot = 50
	ElseIf $rRd = 6 Then
		$sctot = 100
	EndIf
EndFunc

Func PlayTime()
	$SetC = 0
	Local $totsc1 = "", $totsc2 = ""
	Global $ArrPos[12] = ["10,70", "90,70", "170,70", "10,155", "90,155", "170,155", "10,240", "90,240", "170,240", "10,325", "90,325", "170,325" ]
	Global $AraPos[12] = ["305,70", "385,70", "465,70", "305,155", "385,155", "465,155", "305,240", "385,240", "465,240", "305,325", "385,325", "465,325" ]

	For $o = 0 To UBound($array) - 1
		GUICtrlDelete($array[$o])
	Next

	$Ran_D = Random(10, 12, 1)
	For $o = 0 To $Ran_D - 1
		$Ran_Y = Random(0, UBound($ArrPos) - 1, 1)
		$Split = StringSplit($ArrPos[$Ran_Y], ",")
		Randompics()
		$totsc1 += $sctot
		$array[$o] = GUICtrlCreatePic($Path & $rRd & ".bmp", $Split[1], $Split[2], 80, 80)
		_ArrayDelete($ArrPos, $Ran_Y)
	Next

	$Ran_D = Random(10, 12, 1)
	For $n = $o To $o + ($Ran_D - 1)
		$Ran_Y = Random(0, UBound($AraPos) - 1, 1)
		$Split = StringSplit($AraPos[$Ran_Y], ",")
		Randompics()
		$totsc2 += $sctot
		$array[$n] = GUICtrlCreatePic($Path & $rRd & ".bmp", $Split[1], $Split[2], 80, 80)
		_ArrayDelete($AraPos, $Ran_Y)
	Next

	If $totsc1 = $totsc2 Then
		PlayTime()
	ElseIf $totsc1 > $totsc2 Then
		GUICtrlSetOnEvent($Gra1, "CorrectAnW")
		GUICtrlSetOnEvent($Gra2, "WrongAnW")
	ElseIf $totsc1 < $totsc2 Then
		GUICtrlSetOnEvent($Gra1, "WrongAnW")
		GUICtrlSetOnEvent($Gra2, "CorrectAnW")
	EndIf
EndFunc

Func CorrectAnW()
	GUICtrlSetOnEvent($Gra1, "")
	GUICtrlSetOnEvent($Gra2, "")
	$SetC = 1
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	GUICtrlSetData($Time, "02:00")
	_FlashControl($AddPic, 300)
	$Score += 1
EndFunc

Func WrongAnW()
	GUICtrlSetOnEvent($Gra1, "")
	GUICtrlSetOnEvent($Gra2, "")
	$SetC = 1
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	GUICtrlSetData($Time, "02:00")
	_FlashControl($AddPic, 300)
EndFunc